import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Form, FormParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询表单设计
 */
export async function pageForm(params: FormParam) {
  const res = await request.get<ApiResult<PageResult<Form>>>(
    MODULES_API_URL + '/cms/form/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询表单设计列表
 */
export async function listForm(params?: FormParam) {
  const res = await request.get<ApiResult<Form[]>>(
    MODULES_API_URL + '/cms/form',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加表单设计
 */
export async function addForm(data: Form) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改表单设计
 */
export async function updateForm(data: Form) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除表单设计
 */
export async function removeForm(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除表单设计
 */
export async function removeBatchForm(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户状态
 */
export async function updateFormStatus(formId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form/status',
    {
      formId,
      status
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询表单设计
 */
export async function getForm(id: number) {
  const res = await request.get<ApiResult<Form>>(
    MODULES_API_URL + '/cms/form/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
